<?php
/**
 * User redirection from SwipeHQ Checkout gateway to order confirmation page
 */
require_once('includes/application_top.php');
require_once('includes/languages/english/modules/payment/swipehq.php');


$ssl_str = 'NONSSL';
if (ENABLE_SSL != 'false') {
    $ssl_str = 'SSL';
}

if (MODULE_PAYMENT_SWIPEHQ_TEST_MODE == 'On') {
    $messageStack->add_session('header', MODULE_PAYMENT_SWIPEHQ_TEXT_TEST_MODE_MESSAGE, 'warning');
}

if (isset($_REQUEST['result']) && ($_REQUEST['result'] == 'accepted' || $_REQUEST['result'] == 'test-accepted')) {
    $redirect_url = zen_href_link(FILENAME_CHECKOUT_SUCCESS, '', $ssl_str, true, false);

    //send emails
    if (!empty($_REQUEST['user_data'])) {
        $order_id = zen_db_prepare_input($_REQUEST['user_data']);
        if (!empty($_SESSION['swipehq_order_' . $order_id])) {
            if (!isset($_SESSION['language']))
                $_SESSION['language'] = 'english';
            if (file_exists(DIR_WS_LANGUAGES . $_SESSION['language'] . '/' . $template_dir_select . 'checkout_process.php')) {
                require(DIR_WS_LANGUAGES . $_SESSION['language'] . '/' . $template_dir_select . 'checkout_process.php');
            } else {
                require(DIR_WS_LANGUAGES . $_SESSION['language'] . '/checkout_process.php');
            }

            require_once(DIR_WS_CLASSES . 'order.php');
            require_once(DIR_WS_CLASSES . 'payment.php');
            $payment_class = new payment($_SESSION['payment']);
            $order = unserialize($_SESSION['swipehq_order_' . $order_id]);

            require_once(DIR_WS_CLASSES . 'order_total.php');
            $order_total_modules = new order_total;
            $order_totals = $order_total_modules->process();
            $order->send_order_email($order_id, 2);

            $zco_notifier->notify('NOTIFY_CHECKOUT_PROCESS_AFTER_SEND_ORDER_EMAIL');
        }
    }

    //empty cart
    $_SESSION['cart']->reset(true);
} else {
    
    if (isset($_REQUEST['response_message']) and $_REQUEST['response_message']!="null" and $_REQUEST['response_message']!=null and !empty($_REQUEST['response_message'])) {
        $response = $_REQUEST['response_message'] . " - " . MODULE_PAYMENT_SWIPEHQ_TEXT_PAYMENT_ERROR_MESSAGE;
    } else {
        $response = MODULE_PAYMENT_SWIPEHQ_TEXT_PAYMENT_ERROR_MESSAGE;
    }
    
    $messageStack->add_session('checkout_payment', $response, 'error');
    
    $redirect_url = zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', $ssl_str, true, false);
}
?>
<body>
    <script type="text/javascript" language="javascript">window.location = "<?php echo $redirect_url; ?>"</script>
    <noscript>
    <?php echo MODULE_PAYMENT_SWIPEHQ_REDIRECT_MESSAGE; ?> - <a href="<?php echo $redirect_url; ?>"><?php echo $redirect_url; ?></a>.
    </noscript>
</body>