<?php

/**
 * Processes callback from SwipeHQ Checkout gateway
 */
require('includes/application_top.php');
include_once((IS_ADMIN_FLAG === true ? DIR_FS_CATALOG_MODULES : DIR_WS_MODULES) . 'payment/swipehq/swipehq_functions.php');

$request = $_REQUEST;

/* debugging */
$msg = date('Y-m-d H:i:s') . ' ----- REQUEST: ' . json_encode($request) . PHP_EOL;
error_log($msg, 3, "logs/swipehq_request_log.log");


if (isset($request['td_user_data']) && isset($request['status'])) {
     
    $order_id = zen_db_prepare_input($request['td_user_data']);

    $is_verified = verify_transaction($request['transaction_id']);

    $msg = date('Y-m-d H:i:s') . ' ----- Trasaction ID: ' . $request['transaction_id'] . ', Is_verified: ' . $is_verified . PHP_EOL;
    error_log($msg, 3, "logs/swipehq_transaction_Varified.log");

    $failed = false;

    if ($is_verified) {
        $status = MODULE_PAYMENT_SWIPEHQ_ORDER_STATUS_ID;
        if ($request['status'] == 'accepted') {
            $status = MODULE_PAYMENT_SWIPEHQ_PROCESSING_STATUS_ID;
        } elseif ($request['status'] == 'test-accepted') {
            $status = MODULE_PAYMENT_SWIPEHQ_TEST_STATUS_ID;
        } elseif ($request['status'] == 'declined' or $request['status'] == 'test-declined') {
            $status = MODULE_PAYMENT_SWIPEHQ_ORDER_STATUS_ID;
            $failed = true;
        } else {
            die();
        }


        if (!$failed) {
            // Payment was successful, so update the order's state
            $res = $db->Execute("UPDATE " . TABLE_ORDERS . " SET orders_status=" . $status . " WHERE orders_id = '" . $order_id . "'");

            $comments = 'SwipeHQ Payment \n \n Status: ' . $request['status'] . ' \n Date: ' . date("D j/n/Y H:i") . (($_POST['transaction_id'] != '') ? "\n" . ' Transaction ID:' . $_POST['transaction_id'] : '') . "\n" . ' Identifier ID:' . $_POST['identifier_id'] . "\n" . ' Amount: ' . $_POST['amount'] . ' ' . $_POST['currency'];

            $query = "INSERT INTO " . TABLE_ORDERS_STATUS_HISTORY
                    . " (orders_id,"
                    . "orders_status_id,"
                    . "date_added,"
                    . "comments,"
                    . "customer_notified"
                    . ") "
                    . "VALUES ("
                    . "'" . (int) $order_id . "',"
                    . "'" . (int) $status . "',"
                    . "'" . date('Y-m-d H:i:s') . "',"
                    . "'" . $comments . "',"
                    . "'-1'"
                    . ")";
            $db->Execute($query);
        } else {

            // delete order if payment failed and revert stock
            // revert stock
            $query = $db->Execute("SELECT products_id,products_quantity from " . TABLE_ORDERS_PRODUCTS . " WHERE orders_id = '" . $order_id . "'");
            while (!$query->EOF) {

                $query_product = $db->Execute("SELECT products_quantity,products_id from " . TABLE_PRODUCTS . " WHERE products_id = '" . $query->fields['products_id'] . "'");
                while (!$query_product->EOF) {

                    $totalProducts = $query->fields['products_quantity'] + $query_product->fields['products_quantity'];
                    $db->Execute("UPDATE " . TABLE_PRODUCTS . " SET products_quantity='" . $totalProducts . "' WHERE products_id = '" . $query_product->fields['products_id'] . "'");
                    $query_product->MoveNext();
                }

                $query->MoveNext();
            }


            // delete order
            $db->Execute("DELETE from " . TABLE_ORDERS . " WHERE orders_id = '" . $order_id . "'");
            $db->Execute("DELETE from " . TABLE_ORDERS_PRODUCTS . " WHERE orders_id = '" . $order_id . "'");
            $db->Execute("DELETE from " . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . " WHERE orders_id = '" . $order_id . "'");
            $db->Execute("DELETE from " . TABLE_ORDERS_PRODUCTS_DOWNLOAD . " WHERE orders_id = '" . $order_id . "'");
            $db->Execute("DELETE from " . TABLE_ORDERS_STATUS_HISTORY . " WHERE orders_id = '" . $order_id . "'");
            $db->Execute("DELETE from " . TABLE_ORDERS_TOTAL . " WHERE orders_id = '" . $order_id . "'");
        }

        $msg = date('Y-m-d H:i:s') . ' ----- Order ID: ' . $order_id . ', Status: ' . $status . PHP_EOL;
        error_log($msg, 3, "logs/swipehq_order_log.log");
    }
}